﻿using UnityEngine;
using System.Collections;

namespace GameUtil{
	public class AspectKeep : MonoBehaviour
	{
	    public RectTransform ancherTarget;
		public int width, height;

		private void Start(){
			Camera cam = gameObject.GetComponent<Camera>();
			float baseAspect = height/(float) width;
			float nowAspect = (float) Screen.height/(float) Screen.width;
			float changeAspect;

			if (baseAspect > nowAspect){
				changeAspect = nowAspect/baseAspect;
				cam.rect = new Rect((1 - changeAspect)*0.5f, 0, changeAspect, 1);
			}
			else{
				changeAspect = baseAspect/nowAspect;
				cam.rect = new Rect(0, (1 - changeAspect - 0.25f), 1, changeAspect);
			}
		}
	}
}