﻿using System;
using System.Collections;
using System.Runtime.InteropServices;
using Soukoban;
using UnityEngine;


public class Fuku : MoveObjectBase
{
    private MoveDirection direction = MoveDirection.Down;

    // Use this for initialization
    void Start()
    {
        StartCoroutine(MoveRoutineIterator());
    }

    private IEnumerator MoveRoutineIterator()
    {
        while (true)
        {
            if (game.IsGamePlay == false)
            {
                yield return null;
                continue;
            }
            //状況判断フェイズ。　進行方向と、その先にあるものから次の行動を決定する
            var currentGridType = game.GetRideType(Px, Py); //現在地のRideType

            if (currentGridType == RideObject.RideType.GOAL)
            {
                game.Goal();
                Destroy(this.gameObject);
                AudioManager.Instance.PlayRegistSE("福家に入る");
                AudioManager.Instance.PlayRegistSE("ジングル");
            }

            if (currentGridType == RideObject.RideType.DAIZU)
            {
                //DAIZUを消し去り、Uターン？
                direction = (MoveDirection) (((int) direction + 1)%4); //Uターン
            }

            for (int checkDirection = 1; checkDirection < 4; checkDirection++) //こうすることでチェックを右・左・後ろに出来る
            {
                RideObject.RideType frontGridType = RideObject.RideType.NONE; //ひとつ前
                switch (direction)
                {
                    case MoveDirection.Up:
                        frontGridType = game.GetRideType(Px, Py + 1);
                        break;
                    case MoveDirection.Right:
                        frontGridType = game.GetRideType(Px + 1, Py);
                        break;
                    case MoveDirection.Down:
                        frontGridType = game.GetRideType(Px, Py - 1);
                        break;
                    case MoveDirection.Left:
                        frontGridType = game.GetRideType(Px - 1, Py);
                        break;
                }

                if (frontGridType == RideObject.RideType.WALL)
                {
                    direction = (MoveDirection) (((int) direction + checkDirection)%4);
                }
                else
                {
                    break;
                }
            }


            SetMoveState(direction, WalkState.NORMAL);

            GetComponent<SpriteRenderer>().sortingOrder = 100 - Py*2;

            //移動フェイズ　移動が終わるまでまつ
            yield return new WaitWhile(() => moveState != MoveDirection.None);
        }
    }

    //超重要ゲームインスタンス
    public GameMain game;

    //状況判断→移動→移動終了→状況判断・・・を繰り返す

    // Update is called once per frame
    void Update()
    {
        Move();
        //ピカピカ
        GetComponent<SpriteRenderer>().color = new Color(Mathf.Sin(3*Time.time)/10 + (float) 0.9,
            Mathf.Sin(7*Time.time)/10 + (float) 0.9, Mathf.Sin(2*Time.time)/10 + (float) 0.9);
    }
}