﻿using UnityEngine;
using System.Collections;

public class Grid : MonoBehaviour
{
    public Sprite[] floorSprites;

    public SpriteRenderer floorSpriteRenderer;

    public RideObject[] rideObjectPrefabs;
    public RideObject rideObject;

    private int _floorIndex;
    public int FloorIndex
    {
        set
        {
            _floorIndex = value; 
            floorSpriteRenderer.sprite = floorSprites[value];
        }
        get { return _floorIndex; }
    }

    // Use this for initialization
    void Start ()
    {
        FloorIndex = Random.Range(0, floorSprites.Length);
	}
	
    public void SetCode(char code)
    {
        switch (code)
        {
            //木・果物の木・岩
            case 'w':
            case 'W':
            case 's':
            case 'S':
            case 'r':
            case 'R':
                rideObject = Instantiate(rideObjectPrefabs[0]);
                break;
            case 'b':
            case 'B':
                rideObject = Instantiate(rideObjectPrefabs[1]);
                break;
            case 'g':
            case 'G':
                rideObject = Instantiate(rideObjectPrefabs[2]);
                break;
            case 'H':
                rideObject = Instantiate(rideObjectPrefabs[3]);
                break;
            case 'h':
                rideObject = Instantiate(rideObjectPrefabs[4]);
                break;
            case 'm':
            case 'M':
                rideObject = Instantiate(rideObjectPrefabs[5]);
                break;
        }
        if (rideObject != null)
        {
            rideObject.transform.SetParent(this.transform,false);
            rideObject.SetCode(code);
            var ypos = (int)(transform.localPosition.y / GameMain.GridSize);
            rideObject.renderer.sortingOrder = 100 - ypos * 2 - 1;
        }
    }

    public void RemoveRideObject()
    {
        if (rideObject != null)
        {
            Destroy(rideObject.gameObject);
        }
    }
}
