using UnityEngine;

public class AudioPlayer : MonoBehaviour
{
    /// <summary>
    /// I[fBI\[XB
    /// </summary>
    public AudioSource Source;

    /// <summary>
    /// tF[hCĐsǂB
    /// </summary>
    public bool IsFade;

    /// <summary>
    /// tF[hC鎞̎ԁB
    /// </summary>
    public double FadeInSeconds = 1.0;

    /// <summary>
    /// tF[hCĐǂ
    /// </summary>
    bool IsFadePlaying = false;

    /// <summary>
    /// tF[hAEgĐǂ
    /// </summary>
    bool IsFadeStopping = false;

    /// <summary>
    /// tF[hAEg鎞̎ԁB
    /// </summary>
    double FadeOutSeconds = 1.0;

    /// <summary>
    /// tF[hC/AEgoߎԁB
    /// </summary>
    double FadeDeltaTime = 0;

    /// <summary>
    /// {{[B
    /// </summary>
    float BaseVolume;

    /// <summary>
    /// t[B
    /// </summary>
    void Update()
    {
        // tF[hC
        if (IsFadePlaying)
        {
            FadeDeltaTime += Time.deltaTime;
            if (FadeDeltaTime >= FadeInSeconds)
            {
                FadeDeltaTime = FadeInSeconds;
                IsFadePlaying = false;
            }
            Source.volume = (float)(FadeDeltaTime / FadeInSeconds) * BaseVolume;
        }

        // tF[hAEg
        if (IsFadeStopping)
        {
            FadeDeltaTime += Time.deltaTime;
            if (FadeDeltaTime >= FadeOutSeconds)
            {
                FadeDeltaTime = FadeOutSeconds;
                IsFadePlaying = false;
                Stop();
            }
            Source.volume = (float)(1.0 - FadeDeltaTime / FadeOutSeconds) * BaseVolume;
        }
    }

    /// <summary>
    /// Đs܂B
    /// </summary>
    public void Play()
    {
        // Bgm̏ꍇɂ́ABgm̍Đ~܂B
        var bgm = AudioManager.Instance.AudioBgmPlayers;
        if (bgm != null && bgm != this)
        {
            if (bgm.Source.isPlaying)
            {
                if (IsFade)
                {
                    bgm.StopFadeOut(FadeInSeconds);
                }
                else
                {
                    bgm.Stop();
                }
            }
        }

        BaseVolume = 1;
        FadeDeltaTime = 0;
        Source.volume = 0;
        Source.Play();
        IsFadePlaying = true;
        IsFadeStopping = false;
    }

    /// <summary>
    /// ~s܂B
    /// </summary>
    public void Stop()
    {
        Source.Stop();
        Destroy(this);
    }

    /// <summary>
    /// ~s܂B
    /// <param name="fadeSec">tF[hAEg܂ł̕bB</param>
    /// </summary>
    public void StopFadeOut(double fadeSec)
    {
        BaseVolume = Source.volume;
        FadeDeltaTime = 0;
        FadeOutSeconds = fadeSec;
        IsFadeStopping = true;
        IsFadePlaying = false;
    }

    /// <summary>
    /// ꎞ~s܂B
    /// </summary>
    public void Pause()
    {
        Source.Pause();
    }
}