﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using UnityEngine;
using UnityEngine.Networking;
using Random = UnityEngine.Random;

public class MyUtil {
    //渡された重み付け配列からIndexを得る
    public static int GetRandomIndex(params int[] weightTable)
    {
        var totalWeight = weightTable.Sum();
        var value = Random.Range(1, totalWeight + 1);
        var retIndex = -1;
        for (var i = 0; i < weightTable.Length; ++i)
        {
            if (weightTable[i] >= value)
            {
                retIndex = i;
                break;
            }
            value -= weightTable[i];
        }
        return retIndex;
    }
    private static float sTime;
    public static void TimeMeasureStart()
    {
        sTime = Time.realtimeSinceStartup;
    }
    public static float TimeMeasureEnd(bool isDebugLog = false)
    {
        var t = sTime;
        sTime = Time.realtimeSinceStartup;
        if (isDebugLog)
        {
            Debug.Log("time:" + (sTime-t));
            sTime = Time.realtimeSinceStartup;
        }
        return sTime - t;
    }
}

public static class LinqExtensions
{
    public static T RandomAt<T>(this IEnumerable<T> ie)
    {
        if (ie.Any() == false) return default(T);
        return ie.ElementAt(Random.Range(0, ie.Count()));
    }
}
